SETRES *
 * SET/RESET/POINT FOR LOW-RES COLOR GRAPHICS
 *
 * FOR USE WITH PONG - NOTE EQUATES
 *
 *
 NOPLAY	EQU	3700
 XBALL	EQU	NOPLAY+1
 YBALL	EQU	XBALL+1
 DELTAX	EQU	YBALL+1
 DELTAY	EQU	DELTAX+1
 LFTPDL	EQU	DELTAY+1
 RGTPDL	EQU	LFTPDL+1
 LFTCLR	EQU	RGTPDL+1
 RGTCLR	EQU	LFTCLR+1
 STATUS	EQU	RGTCLR+1
 XCOORD	EQU	STATUS+1
 YCOORD	EQU	XCOORD+1
 COLOR	EQU	YCOORD+1
 OPTION	EQU	COLOR+1
 RESULT	EQU	OPTION+1
 DOTBIT	EQU	RESULT+1
 *
 *   SRPSBR--SET, RESET, POINT SBR
 *   INPUT:  XCOORD--# FROM 0 - 63
 *   	    YCOORD--# FROM 0 - 31
 *	    COLOR---# FROM 1 - 8 IF OPTION = 0
 *	    OPTION--0=SET, 1=RESET, 2=POINT
 *   OUTPUT: RESULT--AS IN BASIC FN POINT(X,Y)
 *
 *   USES FOLLOWING ALGORITHM TO DETERMINE DOT
 *
 *	  X  Y   XLATION    RESULTANT #
 *	  E  E    0  0  (0)     8
 *	  O  E    0  1  (1)     4
 *	  E  O    1  0  (2)     2
 *	  O  O    1  1  (3)     1
 *	  (E=EVEN, O=ODD)
 *
 SRPSBR	PSHS	D,X,Y,CC	SAVE IMPORTANT REGS
 	CLRB			B WILL GET COUNT OF 0-3
 	LDA	XCOORD		GET X-COORDINATE IN A
 	LSRA			DIVIDE X COORD BY 2
 	BCC	DONEX		IF B0 WASN'T SET (X EVEN),
 *				DON'T INC B
 	INCB			X ODD--SET B0 IN B
 DONEX	PSHS	A		SAVE X/2 TEMPORARILY
 	LDA	YCOORD		GET Y-COORDINATE
 	LSRA			DIVIDE Y BY 2
 	BCC	DONEY		IF Y EVEN, B HAS CORRECT
 *				COUNT NOW
 	ORB	#2		SET B1 IN B SINCE Y ODD
 DONEY	PSHS	A		SAVE Y/2 TEMPORARILY
 	LDA	#8		SET BIT IN 1 TO LSR
 BITLP	DECB			DEC CNT OF LSR'S
 	BMI	GOTBIT		DONE WHEN B < 0
 	LSRA			SHIFT BIT IN A LEFT BY 1
 	BRA	BITLP		LOOP TILL A HAS 8,4,2, OR 1
 GOTBIT	STA	DOTBIT		STORE VALUE OF BIT TO SRP
 	PULS	A		GET Y COORD / 2
 	LDB	#32		PUT 32 IN B FOR MULT
 	MUL			Y/2 * 32
 	TFR	X,D		X-FER RESULT TO X
 	PULS	A		GET X COORD / 2
 	LEAX	A,X		ADD X/2 TO Y/2*32
 	LEAX	1024,X		FORM ADDR TO GRAPHICS BLK
 	LDA	0,X		GET WORD NOW IN THIS SPOT
 	LDB	OPTION		GET OPTION (0-2)
 	BEQ	SET		IF 0, OPTION=SET
 	DECB			IS IT 1?
 	BEQ	RESET		IF 1, OPTION=RESET
 	CLRB			OPTION=POINT--SET RESULT
 *				REG TO "OFF"
 	TSTA			IS B7 OF WORD SET?
 	BMI	NOTALF		IF B7 SET, NOT ALPHA MODE
 	ORB	#$00FF		-1=ALPHANUMERIC MODE
 	BRA	EXIPNT		STO RESULT & EXIT
 NOTALF	ANDA	DOTBIT		IS THE BIT SET?
 	BEQ	EXIPNT		IF RESET, RET 0 (IN B)
 	LDB	0,X		GET WORD WE'RE TESTING
 	ANDB	#$007F		CLEAR BIT 7
 	LSRB			RT-JUSTIFY COLOR BITS 6-4
 	LSRB			SO COLOR POINT IS SET TO
 	LSRB			WILL BE RETURNED IN B
 	LSRB
 	INCB			B NOW HAS COLOR TO RET
 EXIPNT	STB	RESULT		STORE RESULT OF POINT
 	BRA	EXISRP		EXIT
 SET	ORA	DOTBIT		SET BIT ON FOR DOT
 	ANDA	#$008F		CLEAR COLOR BITS
 	LDB	COLOR		GET COLOR TO SET DOT
 	DECB			DEC SO IN RANGE 0 - 7
 	LSLB			PUT COLOR IN BITS 6 - 4
 	LSLB
 	LSLB
 	LSLB
 	PSHS	B		PUT COLOR BITS ON STACK
 	ORA	,S+		OR INTO GRAPHIC WD; CLR STK
 	ORA	#$0080		SET GRAPHICS BIT ON
 	STA	0,X		STO WORD IN VIDEO MEMORY
 	BRA	EXISRP		EXIT
 RESET	COM	DOTBIT		SET ALL BITS EXCEPT THE 1
 	ANDA	DOTBIT		RESET BIT FOR THE DOT
 	STA	0,X		STORE WORD WITH DOT RESET
 EXISRP	PULS	D,CC,X,Y	RESTORE SAVED REGS
 	RTS			RETURN
	0,X		STO WORD IN VIDEO MEMORY
 	BRA	EXISRP		EXIT
 RESET	COM	DOTBIT		SET ALL BITS EXCEPT THE 1
 	ANDA	DO